﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.Collections.Specialized;

public class Board : MonoBehaviour {
    GameObject boardObject;
    GameObject finalPic;
    Button retrybutton;
    Button newGamebutton;
    GameObject retrybuttonObject;
    GameObject newGamebuttonObject;
    Vector2 boardCenter;
    public GameObject[] ingredients;
    public Text[] counterTexts;
    public Sprite foodSprite;
    float boardWidth;
    float unitSize;
    System.Random random;
    int numDevisions = 5;
    float instantiateInterval = 1f;
    float time = 0;
    float finalTime = 60;
    bool timeOver = false;
    int currentIngredientIndex = 0;
    int tapCounter = 0;
    bool m_bWaitOver = true;
    bool m_bLevelOver = false;
    int[] takenPos = new int[2];
    List<int[]> takenPositions =  new List<int[]>();
    List<GameObject> instantiatedObjects = new List<GameObject>();
    Dictionary<string, int> currentIngredients = new Dictionary<string, int>();
 
    int[] ramenIngredientThresholds = {2, 1, 4, 4, 3, 1, 2};
    string[] ramenIndexTags = {"egg", "oliveoil", "garlic", "mushroom", "spinach", "carrot", "choppedchives"};
    Text tText;
    private void Awake()
    {
        tText = GameObject.Find("TimeText").GetComponent<Text>();
        boardObject = GameObject.Find("Board");
        finalPic = GameObject.Find("FinalPic");
        boardCenter = new Vector2(boardObject.transform.position.x, boardObject.transform.position.y);
        boardWidth = 2 * boardObject.GetComponent<Renderer>().bounds.extents.x;
        random = new System.Random();
        unitSize = boardWidth / numDevisions;
        retrybuttonObject = GameObject.Find("retryButton");
        newGamebuttonObject = GameObject.Find("newGameButton");
        retrybutton = retrybuttonObject.GetComponent<Button>();
        newGamebutton = newGamebuttonObject.GetComponent<Button>();
        retrybuttonObject.SetActive(false);
        newGamebuttonObject.SetActive(false);
        for (int i = 0; i < ingredients.Length; ++i){
            ingredients[i].transform.localScale = (new Vector3(unitSize, unitSize, 1));
        }
	}
	// Use this for initialization
	void Start () {
        finalPic.SetActive(false);
        StartCoroutine(IngredientInstantiator());
        StartCoroutine(TimeCoroutine());     
        SetTexts(0);
	}

    void Update()
    {

        Vector3 mousePos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
        Vector2 mousePos2D = new Vector2(mousePos.x, mousePos.y);
        if (!timeOver)
        {
            if (!m_bLevelOver && Input.GetMouseButtonDown(0))
            {
                RaycastHit hit;
                Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
                if (Physics.Raycast(ray, out hit))
                {
                    if (hit.collider)
                    {
                        if (m_bWaitOver == true && hit.collider.gameObject.CompareTag(ramenIndexTags[currentIngredientIndex]))
                        {
                            ++tapCounter;
                            SetTexts(currentIngredientIndex);
                            m_bWaitOver = false;
                            if (tapCounter >= ramenIngredientThresholds[currentIngredientIndex])
                            {
                                tapCounter = 0;
                                ++currentIngredientIndex;
                                if (currentIngredientIndex < ramenIndexTags.Length)
                                {
                                    SetTexts(currentIngredientIndex);
                                }
                                else
                                {
                                    FinalStep(true);
                                }
                            }
                        }
                    }
                    /*
                    RaycastHit hit1;

                    if (Physics.Raycast(ray, out hit1))
                    {
                        if (hit.collider)
                        {
                            if (hit.collider.gameObject.CompareTag(ramenIndexTags[currentIngredientIndex]))
                            {
                                ++tapCounter;
                                SetTexts(currentIngredientIndex);
                                if (tapCounter >= ramenIngredientThresholds[currentIngredientIndex])
                                {
                                    tapCounter = 0;
                                    ++currentIngredientIndex;
                                }
                            }
                        }
                    }
                    */
                }
            }
        
        }
        else
        {
            FinalStep(false);
        }
    }
    IEnumerator IngredientInstantiator()
    {
        while (!m_bLevelOver)
        {
            foreach (var ingredient in ingredients)
            {
                bool bNewPosFound = false;
                while (!bNewPosFound)
                {
                    int xIndex = UnityEngine.Random.Range(-numDevisions/2 , numDevisions / 2 + 1);//bad convertion
                    int yIndex = UnityEngine.Random.Range(-numDevisions / 2 , numDevisions / 2 + 1);
                    int[] takenIndex = { xIndex, yIndex };
                    bNewPosFound =  !postionTaken(takenIndex);
                    if (bNewPosFound)
                    {
                        takenPositions.Add(takenIndex);
                        float x = boardCenter.x + xIndex * unitSize;
                        float y = boardCenter.y + yIndex * unitSize;

                        GameObject instantiatedObject = Instantiate(ingredient, new Vector3(x, y, 0), Quaternion.identity);
                        instantiatedObjects.Add(instantiatedObject);
                    }
                }
            }
            yield return new WaitForSeconds(instantiateInterval);
            m_bWaitOver = true;
            foreach (var item in instantiatedObjects)
            {
                Destroy(item);
            }
            instantiatedObjects.Clear();
            takenPositions.Clear();
            if (timeOver)
            {
                break;
            }
        }
    }

    IEnumerator TimeCoroutine()
    {
        Time.timeScale = 1;
        while (!m_bLevelOver)
        {
            time += Time.deltaTime;
            float backwardTime = finalTime - time;
            tText.text = string.Format("t = {0:D2}:{1:D2}.{2:D2} ", (int)backwardTime / 60, (int)backwardTime % 60, (int)((backwardTime % 1) * 100));
            if(time > finalTime){
                timeOver = true;
                break;
            }
              yield return null;
        }
    }
    IEnumerator FinalAnimation()
    {
        float size = 0;
        float speed = 0.05f;
        finalPic.SetActive(true);
        Color puffcolor = finalPic.GetComponentInChildren<SpriteRenderer>().color;
        Color initialColor = puffcolor;
        yield return null;
        int finalSize = 10;
        while (size < finalSize)//hardcode
        {
            size += speed;
            finalPic.transform.localScale = new Vector3(size, size, 0);
            puffcolor.a = (finalSize - size) / finalSize;
            finalPic.GetComponentInChildren<SpriteRenderer>().color = puffcolor;
            yield return null;
        }
        //reset:
        size = 0;
        speed *= 2;//logic error!!!
        finalPic.GetComponentInChildren<SpriteRenderer>().sprite = foodSprite;
        finalPic.transform.localScale = new Vector3(size, size, 0);
        finalPic.GetComponentInChildren<SpriteRenderer>().color = initialColor;
        //  Color foodColor = finalPic.GetComponentInChildren<SpriteRenderer>().color;
      //  finalPic.transform.position = new Vector3(3.4f, finalPic.transform.position.y, finalPic.transform.position.z);
        while (size < finalSize)
        {
            size += speed;
            finalPic.transform.localScale = new Vector3(size, size, 0);
        }
        retrybuttonObject.SetActive(true);
        newGamebuttonObject.SetActive(true);
    }

    bool postionTaken(int[] pos)
    {
        bool positionTaken = false;
        foreach(var item in takenPositions){
            positionTaken = (pos[0] == item[0] && pos[1] == item[1]);
            if (positionTaken)
                break;
        }
        return positionTaken;
    }
    void SetTexts(int currnetPos){
        for (int i = 0; i < counterTexts.Length; ++i){
            if(i == currnetPos){
                counterTexts[i].text = string.Format("{0}/{1}", tapCounter, ramenIngredientThresholds[i]);   
            }
       
            else if(i > currnetPos)
            {
                counterTexts[i].text = "";
            }
        }
    }
    public void onRetryClicked()
    {
        UnityEngine.SceneManagement.SceneManager.LoadScene("BoardScene");
    }
    public void onNewGameClicked()
    {
        UnityEngine.SceneManagement.SceneManager.LoadScene("Menu");
    }
    void FinalStep(bool won){
        if(won){
            StartCoroutine(FinalAnimation());
        }
        else{
            retrybuttonObject.SetActive(true);
        }
        m_bLevelOver = true;
       
    }
}

